//[navigation-core](../../index.md)/[com.chrynan.navigation](index.md)

# Package com.chrynan.navigation

## Types

| Name | Summary |
|---|---|
| [AndroidNavigationHandler](-android-navigation-handler/index.md) | [android]<br>fun interface [AndroidNavigationHandler](-android-navigation-handler/index.md)&lt;[I](-android-navigation-handler/index.md) : [NavigationIntent](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-intent/index.md)&gt; : [NavigationHandler](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-handler/index.md)&lt;[I](-android-navigation-handler/index.md), [AndroidNavigationScope](-android-navigation-scope/index.md)&gt; <br>A [NavigationHandler](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-handler/index.md) used on the Android platform that uses an [AndroidNavigationScope](-android-navigation-scope/index.md). |
| [AndroidNavigationScope](-android-navigation-scope/index.md) | [android]<br>interface [AndroidNavigationScope](-android-navigation-scope/index.md) : [NavigationScope](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-scope/index.md)<br>A [NavigationScope](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-scope/index.md) used on the Android platform that has access to a parent [Activity](https://developer.android.com/reference/kotlin/android/app/Activity.html) that can be used to change Activities or Fragments. |
| [NavigationEvent](-navigation-event/index.md) | [common]<br>sealed class [NavigationEvent](-navigation-event/index.md)&lt;[I](-navigation-event/index.md) : [NavigationIntent](-navigation-intent/index.md)&gt;<br>An event that is sent to a [Navigator](-navigator/index.md) to coordinate the navigation between screens. |
| [NavigationEventHandler](-navigation-event-handler/index.md) | [common]<br>interface [NavigationEventHandler](-navigation-event-handler/index.md)&lt;[I](-navigation-event-handler/index.md) : [NavigationIntent](-navigation-intent/index.md), [S](-navigation-event-handler/index.md) : [NavigationScope](-navigation-scope/index.md)&gt; : [NavigationHandler](-navigation-handler/index.md)&lt;[I](-navigation-event-handler/index.md), [S](-navigation-event-handler/index.md)&gt; <br>A [NavigationHandler](-navigation-handler/index.md) that provides distinct functions for each of the possible [NavigationEvent](-navigation-event/index.md)s. |
| [NavigationEventNavigator](-navigation-event-navigator/index.md) | [common]<br>interface [NavigationEventNavigator](-navigation-event-navigator/index.md)&lt;[I](-navigation-event-navigator/index.md) : [NavigationIntent](-navigation-intent/index.md)&gt; : [Navigator](-navigator/index.md)<br>A [Navigator](-navigator/index.md) that navigates using [NavigationEvent](-navigation-event/index.md)s. This is typically the base [Navigator](-navigator/index.md) but not every UI framework can use it, such as Jetpack Compose, so it is separate from the [Navigator](-navigator/index.md) interface. |
| [NavigationHandler](-navigation-handler/index.md) | [common]<br>fun interface [NavigationHandler](-navigation-handler/index.md)&lt;[I](-navigation-handler/index.md) : [NavigationIntent](-navigation-intent/index.md), [S](-navigation-handler/index.md) : [NavigationScope](-navigation-scope/index.md)&gt;<br>Handles the navigation from a [Navigator](-navigator/index.md). |
| [NavigationIntent](-navigation-intent/index.md) | [common]<br>interface [NavigationIntent](-navigation-intent/index.md)<br>Represents an intent to move to a different screen in the application. This is similar to an Intent but for navigation purposes. |
| [NavigationScope](-navigation-scope/index.md) | [common]<br>interface [NavigationScope](-navigation-scope/index.md)<br>Provides the ability for extra platform specific parameters to be provided to a [Navigator](-navigator/index.md). |
| [Navigator](-navigator/index.md) | [common]<br>interface [Navigator](-navigator/index.md)<br>A [Navigator](-navigator/index.md) is responsible for changing and showing the different Screens in the application. |
| [NavStackDuplicateContentStrategy](-nav-stack-duplicate-content-strategy/index.md) | [common]<br>enum [NavStackDuplicateContentStrategy](-nav-stack-duplicate-content-strategy/index.md) : [Enum](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-enum/index.html)&lt;[NavStackDuplicateContentStrategy](-nav-stack-duplicate-content-strategy/index.md)&gt; |

## Functions

| Name | Summary |
|---|---|
| [goBack](go-back.md) | [common]<br>fun &lt;[I](go-back.md) : [NavigationIntent](-navigation-intent/index.md)&gt; [NavigationEventNavigator](-navigation-event-navigator/index.md)&lt;[I](go-back.md)&gt;.[goBack](go-back.md)()<br>A convenience function for calling [NavigationEventNavigator.navigate](-navigation-event-navigator/navigate.md) with [NavigationEvent.Back](-navigation-event/-back/index.md). |
| [goTo](go-to.md) | [common]<br>fun &lt;[I](go-to.md) : [NavigationIntent](-navigation-intent/index.md)&gt; [NavigationEventNavigator](-navigation-event-navigator/index.md)&lt;[I](go-to.md)&gt;.[goTo](go-to.md)(intent: [I](go-to.md))<br>A convenience function for calling [NavigationEventNavigator.navigate](-navigation-event-navigator/navigate.md) with [NavigationEvent.To](-navigation-event/-to/index.md). |
| [goUp](go-up.md) | [common]<br>fun &lt;[I](go-up.md) : [NavigationIntent](-navigation-intent/index.md)&gt; [NavigationEventNavigator](-navigation-event-navigator/index.md)&lt;[I](go-up.md)&gt;.[goUp](go-up.md)()<br>A convenience function for calling [NavigationEventNavigator.navigate](-navigation-event-navigator/navigate.md) with [NavigationEvent.Up](-navigation-event/-up/index.md). |
| [navigator](navigator.md) | [android]<br>fun &lt;[I](navigator.md) : [NavigationIntent](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-intent/index.md)&gt; [navigator](navigator.md)(activity: [Activity](https://developer.android.com/reference/kotlin/android/app/Activity.html), handler: [AndroidNavigationHandler](-android-navigation-handler/index.md)&lt;[I](navigator.md)&gt;): [NavigationEventNavigator](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-event-navigator/index.md)&lt;[I](navigator.md)&gt;<br>Creates a [Navigator](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigator/index.md) using the provided [Activity](https://developer.android.com/reference/kotlin/android/app/Activity.html) in the [AndroidNavigationScope](-android-navigation-scope/index.md) and the provided [handler](navigator.md).<br>[android]<br>fun &lt;[I](navigator.md) : [NavigationIntent](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-intent/index.md)&gt; [navigator](navigator.md)(activity: [Activity](https://developer.android.com/reference/kotlin/android/app/Activity.html), onGoBack: () -&gt; [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html) = { activity.onBackPressed() }, onGoUp: () -&gt; [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html) = { activity.onBackPressed() }, onGoTo: ([I](navigator.md)) -&gt; [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)): [NavigationEventNavigator](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigation-event-navigator/index.md)&lt;[I](navigator.md)&gt;<br>Creates a [Navigator](../../../navigation-core/navigation-core/com.chrynan.navigation/-navigator/index.md) using the provided [Activity](https://developer.android.com/reference/kotlin/android/app/Activity.html) in the [AndroidNavigationScope](-android-navigation-scope/index.md) and the provided [onGoBack](navigator.md), [onGoUp](navigator.md), and [onGoTo](navigator.md) functions to construct an [AndroidNavigationHandler](-android-navigation-handler/index.md). |
